package Autodesk.ADN.Material;

//////////////////////////////////////////////////////////////////////////////////////
// Material Class
//
//////////////////////////////////////////////////////////////////////////////////////
public class AdnMaterial 
{
	public String Name;
	public String Price;
	public String Manufacturer;
	
	public AdnMaterialProperty[] GetProperties()
	{
		return new AdnMaterialProperty[]
		{
			new AdnMaterialProperty("Name", Name, false),
			new AdnMaterialProperty("Price", Price, true),
			new AdnMaterialProperty("Manufacturer", Manufacturer, true)
		};
	}
	
	public void SetProperty(AdnMaterialProperty property)
	{
		if(property.Name == "Name")
		{
			Name = property.Value;
		}
		else if(property.Name == "Price")
		{
			Price = property.Value;
		}
		else if(property.Name == "Manufacturer")
		{
			Manufacturer = property.Value;
		}
	}
}

//////////////////////////////////////////////////////////////////////////////////////
// MaterialProperty Class
//
//////////////////////////////////////////////////////////////////////////////////////
class AdnMaterialProperty
{
    public String Name;
    public String Value;
    public boolean Editable;
    
    public AdnMaterialProperty(
		String name, 
		String value, 
		boolean editable)
    {
    	Name = name;
    	Value = value;
    	Editable = editable;
    }
}

