//
//  ServerConnection.m
//  RevitServerClient
//
//  Created by Adam Nagy on 02/04/2012.
//  Copyright (c) 2012 Autodek. All rights reserved.
//

#import "ServerConnection.h"
#import <Foundation/NSJSONSerialization.h>

#pragma mark - ServerConnection

@implementation ServerConnection

+(void)showAlert:(NSString *)message withTitle:(NSString *)title
{
  [[[UIAlertView alloc] initWithTitle:title message:message 
    delegate:nil cancelButtonTitle:@"OK" otherButtonTitles:nil] show];
}

+ (NSData *)getData:(NSString *)info
{
  NSError * err = nil;

  NSString * urlString =
    [NSString stringWithFormat:@"http://adnmaterial.cloudapp.net/MaterialSrv.svc/rest/%@", info];

  NSURL * url =
   [NSURL URLWithString:urlString];
  NSURLRequest * req =
    [NSMutableURLRequest requestWithURL:url];
  NSData * data =
    [NSURLConnection sendSynchronousRequest:req returningResponse:nil error:&err];
    
  return data;
}
 
+ (void)setData:(NSString *)info withData:(NSData *)data
{
  NSError * err = nil;

  NSString * urlString =
    [NSString stringWithFormat:@"http://adnmaterial.cloudapp.net/MaterialSrv.svc/rest/%@", info];

  NSURL * url =
   [NSURL URLWithString:urlString];
  NSMutableURLRequest * req =
    [NSMutableURLRequest requestWithURL:url];
  
 [req setValue:@"application/json" forHTTPHeaderField:@"Content-Type"];
 [req setHTTPMethod:@"POST"];
 [req setHTTPBody:data]; 
  
 [NSURLConnection sendSynchronousRequest:req returningResponse:nil error:&err];
}

+ (NSArray *)getMaterials
{
  NSError * err = nil;

  NSData * data = [ServerConnection getData:@"Materials"];
  
  NSArray * json = [NSJSONSerialization
                              JSONObjectWithData:data 
                              options:NSJSONReadingMutableContainers 
                              error:&err];
  return json;
}

+ (void)setMaterial:(NSDictionary *)data
{
  NSError * err = nil;

  NSData * json = [NSJSONSerialization
    dataWithJSONObject:data
    options:0
    error:&err];
  
  [ServerConnection setData:@"Material" withData:json];
}

@end
