﻿<%@ Page Title="Home Page" Language="C#" MasterPageFile="~/Site.master" AutoEventWireup="true"
    CodeBehind="Default.aspx.cs" Inherits="AdnMaterialWeb._Default" %>

<asp:Content ID="HeaderContent" runat="server" ContentPlaceHolderID="HeadContent">
</asp:Content>

<asp:Content ID="BodyContent" runat="server" ContentPlaceHolderID="MainContent">
    <script type="text/javascript" src="Scripts/jquery-1.4.1.js"></script>
    <script type="text/javascript" src="Scripts/jquery-1.4.1.min.js"></script>
    <script type="text/javascript">

        $(document).ready(function () {
            $("#loading-div-background").css({ opacity: 0.5 });

        });

        function ShowWaitDialog() {
            $("#loading-div-background").show();
        }

        function HideWaitDialog() {
            $("#loading-div-background").hide();
        } 

        /////////////////////////////////////////////////////////////////////////////
        // 
        //
        /////////////////////////////////////////////////////////////////////////////
        var baseAddress = "adnmaterial.cloudapp.net";
        //var baseAddress = "localhost:81";

        /////////////////////////////////////////////////////////////////////////////
        // 
        //
        /////////////////////////////////////////////////////////////////////////////
        window.onload = OnWindowLoad;

        function OnWindowLoad() {

            RefreshMaterials();

        }

        /////////////////////////////////////////////////////////////////////////////
        // 
        //
        /////////////////////////////////////////////////////////////////////////////
        function ExecutePageMethod(page, fn, args, successFn, errorFn) {

            $.ajax({
                type: "POST",
                url: page + "/" + fn,
                contentType: "application/json; charset=utf-8",
                data: args,
                dataType: "json",
                success: successFn,
                error: errorFn
            });
        }

        /////////////////////////////////////////////////////////////////////////////
        // 
        //
        /////////////////////////////////////////////////////////////////////////////
        function CreateMaterialProps(
            materialName,
            price,
            manufacturer) {

            this.Name = materialName;
            this.Price = price;
            this.Manufacturer = manufacturer;
        }

        /////////////////////////////////////////////////////////////////////////////
        // 
        //
        /////////////////////////////////////////////////////////////////////////////
        function RefreshMaterials() {

            // Get the JsonP data
            $.getJSON('http://' + baseAddress + '/MaterialSrv.svc/rest/Materials?callback=?',
                null,
                function (materials) {
                    $.each(materials,
                        function () {

                            addRow('dataTable', this.Name, this.Price, this.Manufacturer);
                        });
                });
        };

        /////////////////////////////////////////////////////////////////////////////
        // 
        //
        /////////////////////////////////////////////////////////////////////////////
        function addToCombo(material) {

            var combo = document.getElementById("combo");
            var option = document.createElement("option");

            option.text = material.Name;
            option.name = material.Name;
            option.price = material.Price;
            option.manufacturer = material.Manufacturer;

            try {
                combo.add(option, null);
            }
            catch (error) {
                combo.add(option); // IE only
            }
        }

        /////////////////////////////////////////////////////////////////////////////
        // 
        //
        /////////////////////////////////////////////////////////////////////////////
        function OnMaterialSelected() {

            var combo = document.getElementById("combo");
            var price = document.getElementById("price");
            var manu = document.getElementById("manufacturer");

            var option = combo.options[combo.selectedIndex];

            price.value = option.price;
            manu.value = option.manufacturer;
        }

        /////////////////////////////////////////////////////////////////////////////
        // 
        //
        /////////////////////////////////////////////////////////////////////////////
        function UploadMaterialProperties() {

            var table = document.getElementById('dataTable');
            var rowCount = table.rows.length;

            var materials = new Array();

            for (var i = 2; i < rowCount; i++) {
                var row = table.rows[i];

                var name = row.cells[0].innerHTML;
                var price = row.cells[1].childNodes[0].value;
                var manufacturer = row.cells[2].childNodes[0].value;

                var material = new CreateMaterialProps(
                    name,
                    price, 
                    manufacturer);

                materials[i - 2] = material;
            }

            var jsonMsg = "{\'materials\':\'" + JSON.stringify(materials) + "\' }";

            ShowWaitDialog();

            ExecutePageMethod(
                    "Default.aspx",
                    "UploadMaterial",
                    jsonMsg,
                    OnSuccess,
                    OnFailure);
        }

        /////////////////////////////////////////////////////////////////////////////
        // 
        //
        /////////////////////////////////////////////////////////////////////////////
        function OnFailure(result) {

            HideWaitDialog();
        }

        function OnSuccess(result) {

            HideWaitDialog();

            var res = result.d;

            if(res)
            {

            }
        }

        /////////////////////////////////////////////////////////////////////////////
        // 
        //
        /////////////////////////////////////////////////////////////////////////////
        function addRow(tableId, material, price, manufacturer) {

            var table = document.getElementById(tableId);

            var rowCount = table.rows.length;
            var row = table.insertRow(rowCount);

            var cell1 = row.insertCell(0);
            cell1.innerHTML = material;

            var cell2 = row.insertCell(1);
            var element2 = document.createElement("input");
            element2.type = "text";
            element2.value = price;
            cell2.appendChild(element2);

            var cell3 = row.insertCell(2);
            var element3 = document.createElement("input");
            element3.type = "text";
            element3.value = manufacturer;
            cell3.appendChild(element3);
        }
        
    </script>

    <style type="text/css">
                
        #loading-div-background  
        {
            display:none;
            position:fixed;
            top:0;
            left:0;
            background:black;
            width:100%;
            height:100%;
            z-index:1000;
        } 
     
        #loading-div
        {
            width: 300px;
            height: 200px;
            background-color: white;
            text-align:center;
            position:absolute;
            left: 50%;
            top: 50%;
            margin-left:-150px;
            margin-top: -100px;
            z-index:1001;
        }
        
        #loading-div h2
        {
            font-family:Segoe UI,Calibri,Tahoma;
            text-decoration:none;
        }
    
    </style>

    <div id="loading-div-background">
        <div class="ui-corner-all" id="loading-div">
        <img alt="Loading.." src="./resources/loading.gif" style="height: 30px; margin: 30px;" /> 
        <br />
        <h2 style="color: black; font-weight: bold ;">
            Uploading Materials....
        </h2>
        </div>
    </div>


    <h2>
        ADN Material Demo 
    </h2>

    <br />

    <br />

    <table id="dataTable" width="100%" border="1">
        <tr>
            <th style="width:33%">Material</th>
            <th style="width:33%">Price (US$/kg)</th>
            <th style="width:34%">Manufacturer</th>
        </tr>
        <tr>

        </tr>
    </table>
   
    <br />

    <br />

    <input type="button" value="Commit Changes" onclick="UploadMaterialProperties()"/>

</asp:Content>
