﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Net;
using System.Runtime.Serialization;
using System.Runtime.Serialization.Json;
using System.IO;
using System.Text;
using Newtonsoft.Json;
using System.Web.Services;
using System.Web.Script.Services;

namespace AdnMaterialWeb
{
    public partial class _Default : System.Web.UI.Page
    {
        //static string _hostAddress = "127.0.0.1:81";
        static string _hostAddress = "adnmaterial.cloudapp.net";
        
        [DataContract]
        public class AdnMaterial
        {
            public AdnMaterial(
                string name,
                double price,
                string manufacturer)
            {
                Name = name;

                Price = price;

                Manufacturer = manufacturer;
            }

            [DataMember]
            public string Name
            {
                get;
                set;
            }

            [DataMember]
            public double Price
            {
                get;
                set;
            }

            [DataMember]
            public string Manufacturer
            {
                get;
                set;
            }
        }

        /////////////////////////////////////////////////////////////////////////////
        // 
        //
        /////////////////////////////////////////////////////////////////////////////
        public static T ToObjectFromJSON<T>(string jsonString)
        {
            var serializer = new DataContractJsonSerializer(typeof(T));

            using (var memoryStream =
                new MemoryStream(Encoding.Unicode.GetBytes(jsonString)))
            {
                var newObject = (T)serializer.ReadObject(memoryStream);
                memoryStream.Close();

                return newObject;
            }
        }

        static byte[] GetBytes(string str)
        {
            byte[] bytes = new byte[str.Length * sizeof(char)];
            System.Buffer.BlockCopy(str.ToCharArray(), 0, bytes, 0, bytes.Length);
            return bytes;
        }

        [WebMethod]
        [ScriptMethod(ResponseFormat = ResponseFormat.Json)]
        public static bool UploadMaterial(string materials)
        {
            try
            {
                AdnMaterial[] materialsObj =
                    ToObjectFromJSON<AdnMaterial[]>(
                        materials.Replace("\n", ""));

                string url =
                   "http://" + _hostAddress + "/MaterialSrv.svc/rest/Material";

                foreach (AdnMaterial material in materialsObj)
                {
                    WebClient WC = new WebClient();
                    WC.Headers["Content-type"] = "application/json";

                    string jsonMsg = JsonConvert.SerializeObject(material,
                        Formatting.None,
                        new JsonSerializerSettings { });

                    byte[] uploadData = GetBytes(jsonMsg);

                    WC.UploadData(new Uri(url), "POST", uploadData);
                }

                return true;
            }
            catch (Exception ex)
            {
                return false;
            }
        }

        /////////////////////////////////////////////////////////////////////////////
        // 
        //
        /////////////////////////////////////////////////////////////////////////////
        protected void Page_Load(object sender, EventArgs e)
        {

        }
    }
}
